from tkinter import *
import math

# рисование звезды; x0,y0 - координаты центра, clr - цвет,
# rout,rin - радиусы описанной и вписанной окружности
def star(x0, y0, rout, rin, clr):
    a=-0.1 * math.pi
    krd=[]
    for i in range(5):
        krd.append([x0 + rout * math.cos(a),y0 + rout * math.sin(a)])
        krd.append([x0 + rin * math.cos(a - 0.2 * math.pi),
                    y0 + rin * math.sin(a - 0.2 * math.pi)])
        a -= 0.4 * math.pi
    cnvs.create_polygon(krd, fill=clr, outline="blue", width=8)

root = Tk()
root.title(" Векторная графика")
cnvs=Canvas(root, width=520, height=360, bg='#faffff')
cnvs.pack(expand=1, fill='both')
# ======== использование графических методов ===========
cnvs.create_text(20, 10, text="20,10", font=("Helvectica", "10"))
cnvs.create_text(460, 350, text="460,350")
cnvs.create_line([[20, 10], [340, 50], [460, 350]], fill="blue",
                 smooth=1, width=3)
cnvs.create_line([[20, 10], [340, 50], [460, 350]], fill="#ff7777",
                 smooth=0, width=2)
cnvs.create_line([[475, 250], [460, 350]], fill="black", width=4, arrow=LAST)
# залитый прямоугольник
cnvs.create_rectangle(20, 50, 100, 100, fill="cyan", outline="blue")
# контур прямоугольника
cnvs.create_rectangle(30, 60, 90, 90, outline="magenta") 
# многоугольники
cnvs.create_polygon([20, 120], [200, 150], [80, 200], fill="orange")
cnvs.create_polygon([20, 210], [120, 210], [300, 340], [20, 340],
                    outline="red", smooth=0, fill='#faffff')
cnvs.create_polygon([20, 210], [120, 210], [300, 340],[20, 340],
                    outline="red", smooth=1, fill='blue')
        
star(160, 100, 50, 25, 'yellow')
cnvs.create_oval([360, 10], [460, 60], fill="gray80")
# эллипс
cnvs.create_arc([200, 230], [270, 330], start=0, extent=135,
                fill="lightgreen")
cnvs.create_arc([210,120], [280,220], start=0, extent=135,
                style=CHORD, fill="green")
cnvs.create_arc([340,230], [410,330], start=45, extent=270,
                style=ARC, outline="darkgreen", width=2)
cnvs.create_arc([120,180], [190,250], start=0, extent=90,
                outline="brown", width=5)
cnvs.create_arc([210,180], [280,250], start=0, extent=180,
                style=CHORD, outline="#aa7777", width=3)
# отображение рисунка
imgs ="van.gif"
img = PhotoImage(file=imgs)
cnvs.create_image(440, 130, image=img)
root.mainloop()
